<?php
namespace Incoviba\old\Proyecto;

use Incoviba\Common\Alias\OldModel as Model;
use Incoviba\old\Venta\UnidadBloqueada;

/**
 *
 * @author Aldarien
 *
 * @property int id
 * @property Proyecto proyecto
 * @property AgenteTipo agente
 * @property date fecha
 * @property float comision
 *
 */
class ProyectoAgente extends Model
{
	public function proyecto()
	{
		return $this->belongsTo(Proyecto::class, 'proyecto')->findOne();
	}
	public function agente()
	{
		return $this->belongsTo(AgenteTipo::class, 'agente')->findOne();
	}
	public function estado()
	{
		return $this->hasMany(EstadoProyectoAgente::class, 'agente')
			->orderByDesc('id')->findOne();
	}
	public function estados()
	{
		return $this->hasMany(EstadoProyectoAgente::class, 'agente')->findMany();
	}
	public function unidadesBloqueadas()
	{
		return $this->hasMany(UnidadBloqueada::class, 'agente')->findMany();
	}
	public function new()
	{
		parent::save();
		$tipo = model(TipoEstadoProyectoAgente::class)->where('descripcion', 'vigente')->findOne();
		$data = [
			'agente' => $this->id,
			'fecha' => $this->fecha,
			'tipo' => $tipo->id
		];
		$estado = model(EstadoProyectoAgente::class)->create($data);
		$estado->save();
	}
}
?>
